commit 89efc8c491b6cc04c1d31057a0c38ac1c93798f0
Author: James Gu <jgu@suse.com>
Date:   Thu Aug 31 15:17:11 2017 -0700
Status: not upstream, local backport to Pike
URL: taken from https://review.openstack.org/#/c/527855/

    Add Cassandra db support
    
    Added cassandra db plugins in persister, inlcuding Java and
    python version.
    
    Depends-On: I9aa250bab206438f9b98bd211d472c0d8fe12bde
    Change-Id: I4bbe48f8fe550385de6ed3e14120850a8542c7c9
    story: 2001231
    task: 5758

Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/PersisterModule.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/PersisterModule.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/PersisterModule.java
@@ -1,6 +1,8 @@
 /*
  * Copyright (c) 2014 Hewlett-Packard Development Company, L.P.
  *
+ * Copyright (c) 2017 SUSE LLC.
+ *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
@@ -46,6 +48,9 @@ import monasca.persister.pipeline.event.
 import monasca.persister.pipeline.event.MetricHandler;
 import monasca.persister.pipeline.event.MetricHandlerFactory;
 import monasca.persister.repository.Repo;
+import monasca.persister.repository.cassandra.CassandraAlarmRepo;
+import monasca.persister.repository.cassandra.CassandraCluster;
+import monasca.persister.repository.cassandra.CassandraMetricRepo;
 import monasca.persister.repository.influxdb.InfluxV9AlarmRepo;
 import monasca.persister.repository.influxdb.InfluxV9MetricRepo;
 import monasca.persister.repository.influxdb.InfluxV9RepoWriter;
@@ -56,7 +61,7 @@ public class PersisterModule extends Abs
 
   private static final String VERTICA = "vertica";
   private static final String INFLUXDB = "influxdb";
-
+  private static final String CASSANDRA = "cassandra";
   private static final String INFLUXDB_V9 = "v9";
 
   private final PersisterConfig config;
@@ -168,6 +173,13 @@ public class PersisterModule extends Abs
       bind(new TypeLiteral<Repo<AlarmStateTransitionedEvent>> () {})
           .to(InfluxV9AlarmRepo.class);
 
+    } else if (config.getDatabaseConfiguration().getDatabaseType().equalsIgnoreCase(CASSANDRA)) {
+      bind(CassandraCluster.class).in(Singleton.class);
+
+      bind(new TypeLiteral<Repo<MetricEnvelope>>() {}).to(CassandraMetricRepo.class);
+
+      bind(new TypeLiteral<Repo<AlarmStateTransitionedEvent>>() {}).to(CassandraAlarmRepo.class);
+
     } else {
 
       System.err.println(
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/configuration/PersisterConfig.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/configuration/PersisterConfig.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/configuration/PersisterConfig.java
@@ -1,6 +1,8 @@
 /*
  * Copyright (c) 2014 Hewlett-Packard Development Company, L.P.
  *
+ * Copyright (c) 2017 SUSE LLC.
+ *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
@@ -19,6 +21,7 @@ package monasca.persister.configuration;
 
 import com.fasterxml.jackson.annotation.JsonProperty;
 
+import monasca.common.configuration.CassandraDbConfiguration;
 import monasca.common.configuration.DatabaseConfiguration;
 import monasca.common.configuration.InfluxDbConfiguration;
 import io.dropwizard.Configuration;
@@ -97,4 +100,12 @@ public class PersisterConfig extends Con
   public InfluxDbConfiguration getInfluxDBConfiguration() {
     return influxDbConfiguration;
   }
+
+  @Valid
+  @JsonProperty
+  private final CassandraDbConfiguration cassandraDbConfiguration = new CassandraDbConfiguration();
+
+  public CassandraDbConfiguration getCassandraDbConfiguration() {
+    return cassandraDbConfiguration;
+  }
 }
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/configuration/PipelineConfig.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/configuration/PipelineConfig.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/configuration/PipelineConfig.java
@@ -42,6 +42,17 @@ public class PipelineConfig {
   @JsonProperty
   Integer maxBatchTime;
 
+  @JsonProperty
+  Integer commitBatchTime;
+
+  public Integer getCommitBatchTime() {
+    return commitBatchTime;
+  }
+
+  public void setCommitBatchTime(Integer commitBatchTime) {
+    this.commitBatchTime = commitBatchTime;
+  }
+
   public String getTopic() {
     return topic;
   }
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/consumer/KafkaChannel.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/consumer/KafkaChannel.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/consumer/KafkaChannel.java
@@ -1,6 +1,8 @@
 /*
  * Copyright (c) 2014 Hewlett-Packard Development Company, L.P.
  *
+ * Copyright (c) 2017 SUSE LLC
+ * 
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
@@ -44,33 +46,50 @@ public class KafkaChannel {
   private final String topic;
   private final ConsumerConnector consumerConnector;
   private final String threadId;
+  private final int commitBatchtimeInMills;
+  private long nextCommitTime;
+  private boolean commitDirty = false;
 
   @Inject
-  public KafkaChannel(
-      PersisterConfig configuration,
-      @Assisted PipelineConfig pipelineConfig,
+  public KafkaChannel(PersisterConfig configuration, @Assisted PipelineConfig pipelineConfig,
       @Assisted String threadId) {
 
     this.topic = pipelineConfig.getTopic();
     this.threadId = threadId;
-    Properties kafkaProperties =
-        createKafkaProperties(configuration.getKafkaConfig(), pipelineConfig);
+    this.commitBatchtimeInMills = pipelineConfig.getCommitBatchTime();
+    nextCommitTime = System.currentTimeMillis() + commitBatchtimeInMills;
+    Properties kafkaProperties = createKafkaProperties(configuration.getKafkaConfig(), pipelineConfig);
     consumerConnector = Consumer.createJavaConsumerConnector(createConsumerConfig(kafkaProperties));
   }
 
   public final void markRead() {
-    this.consumerConnector.commitOffsets();
+    if (commitBatchtimeInMills <= 0) {
+      consumerConnector.commitOffsets();
+    } else if (nextCommitTime <= System.currentTimeMillis()) {
+      consumerConnector.commitOffsets();
+      nextCommitTime = System.currentTimeMillis() + commitBatchtimeInMills;
+      commitDirty = false;
+    } else {
+      commitDirty = true;
+    }
+  }
+
+  public final void markReadIfDirty() {
+    if (commitDirty) {
+      this.consumerConnector.commitOffsets();
+      commitDirty = false;
+    }
   }
 
   public KafkaStream<byte[], byte[]> getKafkaStream() {
     final Map<String, Integer> topicCountMap = new HashMap<>();
     topicCountMap.put(this.topic, 1);
-    Map<String, List<KafkaStream<byte[], byte[]>>> streamMap =
-        this.consumerConnector.createMessageStreams(topicCountMap);
+    Map<String, List<KafkaStream<byte[], byte[]>>> streamMap = this.consumerConnector
+        .createMessageStreams(topicCountMap);
     List<KafkaStream<byte[], byte[]>> streams = streamMap.values().iterator().next();
     if (streams.size() != 1) {
-      throw new IllegalStateException(String.format(
-          "Expected only one stream but instead there are %d", streams.size()));
+      throw new IllegalStateException(
+          String.format("Expected only one stream but instead there are %d", streams.size()));
     }
     return streams.get(0);
   }
@@ -92,32 +111,28 @@ public class KafkaChannel {
     properties.put("consumer.id",
         String.format("%s_%s", pipelineConfig.getConsumerId(), this.threadId));
     properties.put("socket.timeout.ms", kafkaConfig.getSocketTimeoutMs().toString());
-    properties.put("socket.receive.buffer.bytes", kafkaConfig.getSocketReceiveBufferBytes()
-        .toString());
-    properties.put("fetch.message.max.bytes", kafkaConfig.getFetchMessageMaxBytes()
-        .toString());
+    properties.put("socket.receive.buffer.bytes", kafkaConfig.getSocketReceiveBufferBytes().toString());
+    properties.put("fetch.message.max.bytes", kafkaConfig.getFetchMessageMaxBytes().toString());
     // Set auto commit to false because the persister is going to explicitly commit
     properties.put("auto.commit.enable", "false");
-    properties.put("queued.max.message.chunks", kafkaConfig.getQueuedMaxMessageChunks()
-        .toString());
+    properties.put("queued.max.message.chunks", kafkaConfig.getQueuedMaxMessageChunks().toString());
     properties.put("rebalance.max.retries", kafkaConfig.getRebalanceMaxRetries().toString());
     properties.put("fetch.min.bytes", kafkaConfig.getFetchMinBytes().toString());
     properties.put("fetch.wait.max.ms", kafkaConfig.getFetchWaitMaxMs().toString());
     properties.put("rebalance.backoff.ms", kafkaConfig.getRebalanceBackoffMs().toString());
-    properties.put("refresh.leader.backoff.ms", kafkaConfig.getRefreshLeaderBackoffMs()
-        .toString());
+    properties.put("refresh.leader.backoff.ms", kafkaConfig.getRefreshLeaderBackoffMs().toString());
     properties.put("auto.offset.reset", kafkaConfig.getAutoOffsetReset());
     properties.put("consumer.timeout.ms", kafkaConfig.getConsumerTimeoutMs().toString());
     properties.put("client.id", String.format("%s_%s", pipelineConfig.getClientId(), threadId));
-    properties.put("zookeeper.session.timeout.ms", kafkaConfig
-        .getZookeeperSessionTimeoutMs().toString());
-    properties.put("zookeeper.connection.timeout.ms", kafkaConfig
-        .getZookeeperConnectionTimeoutMs().toString());
-    properties
-        .put("zookeeper.sync.time.ms", kafkaConfig.getZookeeperSyncTimeMs().toString());
+    properties.put("zookeeper.session.timeout.ms",
+        kafkaConfig.getZookeeperSessionTimeoutMs().toString());
+    properties.put("zookeeper.connection.timeout.ms",
+        kafkaConfig.getZookeeperConnectionTimeoutMs().toString());
+    properties.put("zookeeper.sync.time.ms", kafkaConfig.getZookeeperSyncTimeMs().toString());
 
     for (String key : properties.stringPropertyNames()) {
-      logger.info("[{}]: " + KAFKA_CONFIGURATION + " " + key + " = " + properties.getProperty(key), threadId);
+      logger.info("[{}]: " + KAFKA_CONFIGURATION + " " + key + " = " + properties.getProperty(key),
+          threadId);
     }
 
     return properties;
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/consumer/KafkaConsumerRunnableBasic.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/consumer/KafkaConsumerRunnableBasic.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/consumer/KafkaConsumerRunnableBasic.java
@@ -1,6 +1,8 @@
 /*
  * Copyright (c) 2014 Hewlett-Packard Development Company, L.P.
  *
+ * Copyright (c) 2017 SUSE LLC.
+ *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
@@ -38,14 +40,13 @@ public class KafkaConsumerRunnableBasic<
   private final String threadId;
   private final ManagedPipeline<T> pipeline;
   private volatile boolean stop = false;
+  private boolean active = false;
 
   private ExecutorService executorService;
 
   @Inject
-  public KafkaConsumerRunnableBasic(
-      @Assisted KafkaChannel kafkaChannel,
-      @Assisted ManagedPipeline<T> pipeline,
-      @Assisted String threadId) {
+  public KafkaConsumerRunnableBasic(@Assisted KafkaChannel kafkaChannel,
+      @Assisted ManagedPipeline<T> pipeline, @Assisted String threadId) {
 
     this.kafkaChannel = kafkaChannel;
     this.pipeline = pipeline;
@@ -67,8 +68,9 @@ public class KafkaConsumerRunnableBasic<
   }
 
   private void markRead() {
-
-    logger.debug("[{}]: marking read", this.threadId);
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: marking read", this.threadId);
+    }
 
     this.kafkaChannel.markRead();
 
@@ -80,12 +82,30 @@ public class KafkaConsumerRunnableBasic<
 
     this.stop = true;
 
+    int count = 0;
+    while (active) {
+      if (count++ >= 20) {
+        break;
+      }
+      try {
+        Thread.sleep(100);
+      } catch (InterruptedException e) {
+        logger.error("interrupted while waiting for the run loop to stop", e);
+        break;
+      }
+    }
+
+    if (!active) {
+      this.kafkaChannel.markReadIfDirty();
+    }
   }
 
   public void run() {
 
     logger.info("[{}]: run", this.threadId);
 
+    active = true;
+
     final ConsumerIterator<byte[], byte[]> it = kafkaChannel.getKafkaStream().iterator();
 
     logger.debug("[{}]: KafkaChannel has stream iterator", this.threadId);
@@ -121,7 +141,9 @@ public class KafkaConsumerRunnableBasic<
 
             final String msg = new String(it.next().message());
 
-            logger.debug("[{}]: {}", this.threadId, msg);
+            if (logger.isDebugEnabled()) {
+              logger.debug("[{}]: {}", this.threadId, msg);
+            }
 
             publishEvent(msg);
 
@@ -149,22 +171,24 @@ public class KafkaConsumerRunnableBasic<
 
       } catch (Throwable e) {
 
-        logger.error(
-            "[{}]: caught fatal exception while publishing msg. Shutting entire persister down "
-            + "now!", this.threadId, e);
+        logger
+            .error("[{}]: caught fatal exception while publishing msg. Shutting entire persister down "
+                + "now!", this.threadId, e);
 
-          logger.error("[{}]: calling shutdown on executor service", this.threadId);
-          this.executorService.shutdownNow();
+        logger.error("[{}]: calling shutdown on executor service", this.threadId);
+        this.executorService.shutdownNow();
 
-          logger.error("[{}]: shutting down system. calling system.exit(1)", this.threadId);
-          System.exit(1);
+        logger.error("[{}]: shutting down system. calling system.exit(1)", this.threadId);
+        System.exit(1);
 
-        }
+      }
 
     }
 
     logger.info("[{}]: calling stop on kafka channel", this.threadId);
 
+    active = false;
+
     this.kafkaChannel.stop();
 
     logger.debug("[{}]: exiting main run loop", this.threadId);
@@ -183,9 +207,10 @@ public class KafkaConsumerRunnableBasic<
 
   private boolean isInterrupted() {
 
-    if (Thread.currentThread().interrupted()) {
-
-      logger.debug("[{}]: is interrupted. breaking out of run loop", this.threadId);
+    if (Thread.interrupted()) {
+      if (logger.isDebugEnabled()) {
+        logger.debug("[{}]: is interrupted. breaking out of run loop", this.threadId);
+      }
 
       return true;
 
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/pipeline/event/FlushableHandler.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/pipeline/event/FlushableHandler.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/pipeline/event/FlushableHandler.java
@@ -1,6 +1,8 @@
 /*
  * Copyright (c) 2014 Hewlett-Packard Development Company, L.P.
  *
+ * Copyright (c) 2017 SUSE LLC
+ * 
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
@@ -51,28 +53,18 @@ public abstract class FlushableHandler<T
 
   protected final String handlerName;
 
-  protected FlushableHandler(
-      PipelineConfig configuration,
-      Environment environment,
-      String threadId,
+  protected FlushableHandler(PipelineConfig configuration, Environment environment, String threadId,
       int batchSize) {
 
     this.threadId = threadId;
 
-    this.handlerName =
-        String.format(
-            "%s[%s]",
-            this.getClass().getName(),
-            threadId);
+    this.handlerName = String.format("%s[%s]", this.getClass().getName(), threadId);
 
-    this.processedMeter =
-        environment.metrics().meter(handlerName + "." + "events-processed-meter");
+    this.processedMeter = environment.metrics().meter(handlerName + "." + "events-processed-meter");
 
-    this.flushMeter =
-        environment.metrics().meter(handlerName + "." + "flush-meter");
+    this.flushMeter = environment.metrics().meter(handlerName + "." + "flush-meter");
 
-    this.flushTimer =
-        environment.metrics().timer(handlerName + "." + "flush-timer");
+    this.flushTimer = environment.metrics().timer(handlerName + "." + "flush-timer");
 
     this.secondsBetweenFlushes = configuration.getMaxBatchTime();
 
@@ -102,7 +94,7 @@ public abstract class FlushableHandler<T
 
       } else {
 
-         return false;
+        return false;
 
       }
     }
@@ -126,20 +118,26 @@ public abstract class FlushableHandler<T
 
   private boolean isBatchSize() {
 
-    logger.debug("[{}]: checking batch size", this.threadId);
+    if (logger.isDebugEnabled()) {
+
+      logger.debug("[{}]: checking batch size", this.threadId);
+
+    }
 
     if (this.msgCount >= this.batchSize) {
 
-      logger.debug("[{}]: batch sized {} attained", this.threadId, this.batchSize);
+      if (logger.isDebugEnabled()) {
+        logger.debug("[{}]: batch sized {} attained", this.threadId, this.batchSize);
+      }
 
       return true;
 
     } else {
 
-      logger.debug("[{}]: batch size now at {}, batch size {} not attained",
-                   this.threadId,
-                   this.msgCount,
-                   this.batchSize);
+      if (logger.isDebugEnabled()) {
+        logger.debug("[{}]: batch size now at {}, batch size {} not attained", this.threadId,
+            this.msgCount, this.batchSize);
+      }
 
       return false;
 
@@ -147,28 +145,26 @@ public abstract class FlushableHandler<T
   }
 
   private boolean isFlushTime() {
-
-    logger.debug("[{}]: got heartbeat message, checking flush time. flush every {} seconds.",
-                 this.threadId,
-                 this.secondsBetweenFlushes);
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: got heartbeat message, checking flush time. flush every {} seconds.",
+          this.threadId, this.secondsBetweenFlushes);
+    }
 
     long now = System.currentTimeMillis();
 
-    if (this.flushTimeMillis <= now ) {
-
-      logger.debug(
-          "[{}]: {} ms past flush time. flushing to repository now.",
-          this.threadId,
-          now - this.flushTimeMillis);
+    if (this.flushTimeMillis <= now) {
+      if (logger.isDebugEnabled()) {
+        logger.debug("[{}]: {} ms past flush time. flushing to repository now.", this.threadId,
+            now - this.flushTimeMillis);
+      }
 
       return true;
 
     } else {
-
-      logger.debug(
-          "[{}]: {} ms to next flush time. no need to flush at this time.",
-          this.threadId,
-          this.flushTimeMillis - now);
+      if (logger.isDebugEnabled()) {
+        logger.debug("[{}]: {} ms to next flush time. no need to flush at this time.", this.threadId,
+            this.flushTimeMillis - now);
+      }
 
       return false;
 
@@ -176,8 +172,9 @@ public abstract class FlushableHandler<T
   }
 
   public int flush() throws RepoException {
-
-    logger.debug("[{}]: flushing", this.threadId);
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: flushing", this.threadId);
+    }
 
     Timer.Context context = this.flushTimer.time();
 
@@ -185,13 +182,15 @@ public abstract class FlushableHandler<T
 
     context.stop();
 
-    this.flushMeter.mark();
+    this.flushMeter.mark(msgFlushCnt);
 
     this.flushTimeMillis = System.currentTimeMillis() + this.millisBetweenFlushes;
 
-    logger.debug("[{}]: flushed {} msg", this.threadId, msgFlushCnt);
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: flushed {} msg", this.threadId, msgFlushCnt);
+    }
 
-    this.msgCount = 0;
+    this.msgCount -= msgFlushCnt;
 
     this.batchCount++;
 
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/pipeline/event/MetricHandler.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/pipeline/event/MetricHandler.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/pipeline/event/MetricHandler.java
@@ -1,6 +1,8 @@
 /*
  * Copyright (c) 2014 Hewlett-Packard Development Company, L.P.
- *
+ * 
+ * Copyright (c) 2017 SUSE LLC
+ * 
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
@@ -38,28 +40,23 @@ import monasca.persister.repository.Repo
 
 public class MetricHandler extends FlushableHandler<MetricEnvelope[]> {
 
-  private static final Logger logger =
-      LoggerFactory.getLogger(MetricHandler.class);
+  private static final Logger logger = LoggerFactory.getLogger(MetricHandler.class);
 
   private final Repo<MetricEnvelope> metricRepo;
 
   private final Counter metricCounter;
 
   @Inject
-  public MetricHandler(
-      Repo<MetricEnvelope> metricRepo,
-      Environment environment,
-      @Assisted PipelineConfig configuration,
-      @Assisted("threadId") String threadId,
+  public MetricHandler(Repo<MetricEnvelope> metricRepo, Environment environment,
+      @Assisted PipelineConfig configuration, @Assisted("threadId") String threadId,
       @Assisted("batchSize") int batchSize) {
 
     super(configuration, environment, threadId, batchSize);
 
     this.metricRepo = metricRepo;
 
-    this.metricCounter =
-        environment.metrics()
-            .counter(this.handlerName + "." + "metrics-added-to-batch-counter");
+    this.metricCounter = environment.metrics()
+        .counter(this.handlerName + "." + "metrics-added-to-batch-counter");
 
   }
 
@@ -89,12 +86,10 @@ public class MetricHandler extends Flush
   }
 
   private void processEnvelope(MetricEnvelope metricEnvelope) {
-
-    logger.debug("[{}]: [{}:{}] {}",
-                 this.threadId,
-                 this.getBatchCount(),
-                 this.getMsgCount(),
-                 metricEnvelope);
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: [{}:{}] {}", this.threadId, this.getBatchCount(), this.getMsgCount(),
+          metricEnvelope);
+    }
 
     this.metricRepo.addToBatch(metricEnvelope, this.threadId);
 
@@ -109,8 +104,8 @@ public class MetricHandler extends Flush
 
     this.objectMapper.enable(DeserializationFeature.ACCEPT_SINGLE_VALUE_AS_ARRAY);
 
-    this.objectMapper.setPropertyNamingStrategy(
-        PropertyNamingStrategy.CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES);
+    this.objectMapper
+        .setPropertyNamingStrategy(PropertyNamingStrategy.CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES);
 
   }
 
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/Sha1HashId.java
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/Sha1HashId.java
@@ -0,0 +1,73 @@
+/*
+ * Copyright (c) 2014 Hewlett-Packard Development Company, L.P.
+ *
+ * Copyright (c) 2017 SUSE LLC.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+ * implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package monasca.persister.repository;
+
+import org.apache.commons.codec.binary.Hex;
+
+import java.nio.ByteBuffer;
+import java.util.Arrays;
+
+public class Sha1HashId {
+  private final byte[] sha1Hash;
+
+  private final String hex;
+
+  public Sha1HashId(byte[] sha1Hash) {
+    this.sha1Hash = sha1Hash;
+    hex = Hex.encodeHexString(sha1Hash);
+  }
+
+  @Override
+  public String toString() {
+    return "Sha1HashId{" + "sha1Hash=" + hex + "}";
+  }
+
+  @Override
+  public boolean equals(Object o) {
+    if (this == o)
+      return true;
+    if (!(o instanceof Sha1HashId))
+      return false;
+
+    Sha1HashId that = (Sha1HashId) o;
+
+    if (!Arrays.equals(sha1Hash, that.sha1Hash))
+      return false;
+
+    return true;
+  }
+
+  @Override
+  public int hashCode() {
+    return Arrays.hashCode(sha1Hash);
+  }
+
+  public byte[] getSha1Hash() {
+    return sha1Hash;
+  }
+
+  public ByteBuffer getSha1HashByteBuffer() {
+    return ByteBuffer.wrap(sha1Hash);
+  }
+
+  public String toHexString() {
+    return hex;
+  }
+}
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/CassandraAlarmRepo.java
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/CassandraAlarmRepo.java
@@ -0,0 +1,113 @@
+/*
+ * Copyright (c) 2017 SUSE LLC
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+ * implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package monasca.persister.repository.cassandra;
+
+import java.security.NoSuchAlgorithmException;
+import java.sql.SQLException;
+import java.sql.Timestamp;
+
+import javax.inject.Inject;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.PropertyNamingStrategy;
+
+import io.dropwizard.setup.Environment;
+import monasca.common.model.event.AlarmStateTransitionedEvent;
+import monasca.persister.configuration.PersisterConfig;
+import monasca.persister.repository.Repo;
+import monasca.persister.repository.RepoException;
+
+/**
+ * This class is not thread safe.
+ *
+ */
+public class CassandraAlarmRepo extends CassandraRepo implements Repo<AlarmStateTransitionedEvent> {
+
+  private static final Logger logger = LoggerFactory.getLogger(CassandraAlarmRepo.class);
+
+  private static String EMPTY_REASON_DATA = "{}";
+
+  private static final int MAX_BYTES_PER_CHAR = 4;
+  private static final int MAX_LENGTH_VARCHAR = 65000;
+
+  private int retention;
+
+  private ObjectMapper objectMapper = new ObjectMapper();
+
+  @Inject
+  public CassandraAlarmRepo(CassandraCluster cluster, PersisterConfig config, Environment environment)
+      throws NoSuchAlgorithmException, SQLException {
+    super(cluster, environment, config.getCassandraDbConfiguration().getMaxWriteRetries(),
+        config.getAlarmHistoryConfiguration().getBatchSize());
+
+    this.retention = config.getCassandraDbConfiguration().getRetentionPolicy() * 24 * 3600;
+
+    logger.debug("Instantiating " + this.getClass().getName());
+
+    this.objectMapper
+        .setPropertyNamingStrategy(PropertyNamingStrategy.CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES);
+
+    session = cluster.getAlarmsSession();
+
+    logger.debug(this.getClass().getName() + " is fully instantiated");
+
+  }
+
+  public void addToBatch(AlarmStateTransitionedEvent message, String id) {
+
+    String metricsString = getSerializedString(message.metrics, id);
+
+    // Validate metricsString does not exceed a sufficient maximum upper bound
+    if (metricsString.length() * MAX_BYTES_PER_CHAR >= MAX_LENGTH_VARCHAR) {
+      metricsString = "[]";
+      logger.warn("length of metricsString for alarm ID {} exceeds max length of {}", message.alarmId,
+          MAX_LENGTH_VARCHAR);
+    }
+
+    String subAlarmsString = getSerializedString(message.subAlarms, id);
+
+    if (subAlarmsString.length() * MAX_BYTES_PER_CHAR >= MAX_LENGTH_VARCHAR) {
+      subAlarmsString = "[]";
+      logger.warn("length of subAlarmsString for alarm ID {} exceeds max length of {}", message.alarmId,
+          MAX_LENGTH_VARCHAR);
+    }
+
+    queue.offerLast(cluster.getAlarmHistoryInsertStmt().bind(retention, metricsString, message.oldState.name(),
+        message.newState.name(), subAlarmsString, message.stateChangeReason, EMPTY_REASON_DATA,
+        message.tenantId, message.alarmId, new Timestamp(message.timestamp)));
+  }
+
+  private String getSerializedString(Object o, String id) {
+
+    try {
+      return this.objectMapper.writeValueAsString(o);
+    } catch (JsonProcessingException e) {
+      logger.error("[[}]: failed to serialize object {}", id, o, e);
+      return "";
+    }
+  }
+
+  @Override
+  public int flush(String id) throws RepoException {
+    return handleFlush(id);
+  }
+}
